﻿using EonaCat.Json;
using System;

namespace EonaCat.BlockChain
{
    public static class ClientServerExample
    {
        public static int ServerPort;
        private static P2PServer _server;
        private static readonly P2PClient Client = new P2PClient();
        public static BlockChain BlockChain = new BlockChain();
        private static string _clientUsername = "Unknown";

        public static void Run(int serverPort, string clientUsername)
        {
            BlockChain.InitializeChain();

            ServerPort = serverPort;
            _clientUsername = clientUsername;

            if (ServerPort > 0)
            {
                _server = new P2PServer();
                _server.Start();
            }

            if (_clientUsername != "Unknown")
            {
                Console.WriteLine($"Current user is {_clientUsername}");
            }

            Console.WriteLine("=========================");
            Console.WriteLine("EonaCat BlockChain");
            Console.WriteLine("1. Connect to a server");
            Console.WriteLine("2. Add a transaction");
            Console.WriteLine("3. Display BlockChain");
            Console.WriteLine("4. Exit");
            Console.WriteLine("=========================");

            int selection = 0;
            while (selection != 4)
            {
                switch (selection)
                {
                    case 1:
                        Console.WriteLine("Please enter the server URL");
                        string serverUrl = Console.ReadLine();
                        Client.Connect($"{serverUrl}/BlockChain");
                        break;

                    case 2:
                        Console.WriteLine("Please enter the receiver name");
                        string receiverName = Console.ReadLine();
                        Console.WriteLine("Please enter the amount");
                        string amount = Console.ReadLine();
                        BlockChain.CreateTransaction(new Transaction(_clientUsername, receiverName, int.Parse(amount)));
                        BlockChain.ProcessPendingTransactions(_clientUsername);
                        Client.Broadcast(JsonHelper.ToJson(BlockChain));
                        break;

                    case 3:
                        Console.WriteLine("BlockChain");
                        Console.WriteLine(JsonHelper.ToJson(BlockChain, Formatting.Indented));
                        break;
                }

                Console.WriteLine("Please select an action");
                string action = Console.ReadLine();
                selection = int.Parse(action);
            }

            Client.Close();
        }
    }
}