// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

using System;

namespace EonaCat.Network
{
    public class WSException : Exception
    {
        internal WSException()
          : this(CloseStatusCode.Abnormal, null, null)
        {
        }

        internal WSException(Exception innerException)
          : this(CloseStatusCode.Abnormal, null, innerException)
        {
        }

        internal WSException(string message)
          : this(CloseStatusCode.Abnormal, message, null)
        {
        }

        internal WSException(CloseStatusCode code)
          : this(code, null, null)
        {
        }

        internal WSException(string message, Exception innerException)
          : this(CloseStatusCode.Abnormal, message, innerException)
        {
        }

        internal WSException(CloseStatusCode code, Exception innerException)
          : this(code, null, innerException)
        {
        }

        internal WSException(CloseStatusCode code, string message)
          : this(code, message, null)
        {
        }

        internal WSException(
          CloseStatusCode code, string message, Exception innerException
        )
          : base("EonaCat Network: " + (message ?? code.GetMessage()), innerException)
        {
            Code = code;
        }

        public CloseStatusCode Code { get; }
    }
}